
!Algertype methodsFor: '*OB-Algernon' stamp: 'EstebanLorenzano 10/5/2009 20:09'!
isOmniBrowser: aBrowser
	^(aBrowser isKindOf: OBBrowser) 
		or: [ aBrowser isKindOf: O2Browser ]! !

!Algertype methodsFor: '*OB-Algernon' stamp: 'EstebanLorenzano 10/5/2009 20:10'!
isOmniBrowserClass: aBrowserClass
	^(aBrowserClass withAllSuperclasses includes: OBBrowser) 
		or: [ aBrowserClass withAllSuperclasses includes: O2Browser ]! !

!Algertype methodsFor: '*OB-Algernon' stamp: 'KS 5/15/2008 19:00'!
openInExistingBrowser: anObject
	|browser|
	browser := Algernon existingBrowser.
	browser 
		ifNil:[ self openInNewBrowser: anObject ]
		ifNotNil: [ self open: anObject inBrowser: browser ]
	! !

!Algertype methodsFor: '*OB-Algernon' stamp: 'EL 9/4/2008 18:08'!
openInNewBrowser: anObject
	| browserClass browser |
	
	browserClass := Algernon browser.
	(self isOmniBrowserClass: browserClass)
		ifTrue: [ 
			browser := browserClass new. 
			browser open ]
		ifFalse: [ 
			browser := browserClass open ].
	
	self open: anObject inBrowser: browser.! !

!ClassAlgertype methodsFor: '*OB-Algernon' stamp: 'EstebanLorenzano 10/5/2009 20:19'!
classNodeClassFor: aBrowser
	^(Algernon isO2Browser: aBrowser) 
		ifTrue: [ O2ClassNode ]
		ifFalse: [ OBClassNode ]	! !

!ClassAlgertype methodsFor: '*OB-Algernon' stamp: 'EstebanLorenzano 10/5/2009 20:18'!
open: aClass inBrowser: aBrowser
	(self isOmniBrowser: aBrowser)
		ifTrue: [ aBrowser jumpTo: ((self classNodeClassFor: aBrowser) on: aClass) ]
		ifFalse: [ aBrowser setClass: aClass selector: nil ]! !

!CategoryAlgertype methodsFor: '*OB-Algernon' stamp: 'KS 5/15/2008 18:11'!
createListOfAlgeractions
	| list aCategory |
	list := SortedCollection sortBlock: [:a :b | a rank > b rank].
	aCategory := self typeObject.
	"No way to implement the following with the current omni browser"
"		list add: (Algeraction withName:'browse category (existing)' 
					rank:5 target:self selector:#openInExistingBrowser: 
					args:(OrderedCollection with:aCategory)).
		list add: (Algeraction withName:'browse category (new)' 
					rank:4 target:self selector:#openInNewBrowser: 
					args:(OrderedCollection with:aCategory))."
		list add: (Algeraction withName:'fileOut category' 
					rank:3 target:SystemOrganization selector:#fileOutCategory: 
					args:(OrderedCollection with:aCategory)).
	list add: (Algeraction withName:'printOut category' 
					rank:2 target:self selector:#printOutCategory:
					args:(OrderedCollection with:aCategory)).			
	^list.! !

!CategoryAlgertype methodsFor: '*OB-Algernon' stamp: 'KS 5/15/2008 18:10'!
open: aCategory inBrowser: aBrowser

	self shouldBeImplemented. "..... but, there's no way to do this with the current omni browser.'"
	
	aBrowser jumpTo: (OBClassCategoryNode on: aCategory)! !

!Algernon class methodsFor: '*OB-Algernon' stamp: 'EL 9/4/2008 18:10'!
browser
	"Return the class of browser that algernon should use"
	| browser |

	browser := SystemBrowser default.
	(self isOmniBrowserAdaptorClass: browser)
		ifTrue: [ ^browser browserClass ]
		ifFalse: [ ^browser ].! !

!Algernon class methodsFor: '*OB-Algernon' stamp: 'EL 9/7/2008 10:16'!
closeAll
	"Removes all executing instances in World"
	self allInstances first deactivate.
	self allInstances first delete.
	DefaultAlgertems := nil.
	SystemChangeNotifier uniqueInstance 
		noMoreNotificationsFor: self allInstances first.
	Algernon allInstances first delete.
	Smalltalk garbageCollect.

	World submorphs 
		select: [ :each | each class = Algernon ] 
		thenDo: [ :each | World removeMorph: each ] ! !

!Algernon class methodsFor: '*OB-Algernon' stamp: 'KS 5/15/2008 18:54'!
existingBrowser
	"returns an existing open browser"
	"code adapted from similar method in WhiskerBrowser"
	|windows collapsedWindows browserWindow|
	windows := SystemWindow   "(search expanded windows first)"
					windowsIn: self currentWorld
					satisfying: [:w | w isCollapsed not].
	collapsedWindows := SystemWindow
							windowsIn: self currentWorld
							satisfying: [:w | w isCollapsed].
	"windows addAll: collapsedWindows."
	browserWindow := windows detect: [:w | w model isKindOf: self browser] ifNone: [nil].
	
	browserWindow ifNil:[^nil].
	^browserWindow model.! !

!Algernon class methodsFor: '*OB-Algernon' stamp: 'EstebanLorenzano 10/5/2009 20:20'!
isO2Browser: aBrowser
	^aBrowser isKindOf: O2Browser! !

!Algernon class methodsFor: '*OB-Algernon' stamp: 'EstebanLorenzano 10/5/2009 20:08'!
isOmniBrowserAdaptorClass: aBrowser
	^(aBrowser withAllSuperclasses includes: OBSystemBrowserAdaptor)
		or: [ aBrowser withAllSuperclasses includes: O2SystemBrowserAdaptor ]! !

!MethodAlgertype methodsFor: '*OB-Algernon' stamp: 'EstebanLorenzano 10/5/2009 20:17'!
methodNodeClassFor: aBrowser
	^(Algernon isO2Browser: aBrowser) 
		ifTrue: [ O2MethodNode ]
		ifFalse: [ OBMethodNode ]! !

!MethodAlgertype methodsFor: '*OB-Algernon' stamp: 'EstebanLorenzano 10/5/2009 20:16'!
open: aMethod inBrowser: aBrowser
	(self isOmniBrowser: aBrowser)
		ifTrue: [ 
			aBrowser jumpTo: ((self methodNodeClassFor: aBrowser) 
				on: aMethod  inClass: self methodClass) ]
		ifFalse: [ aBrowser setClass: (self methodClass) selector: aMethod ]! !
